/*
 * kbd.c
 *
 * Created: 5.6.2014 16:45:06
 *  Author: maticpi
 */ 

#include "kbd.h"

char lastkey;

void ReadKBD()
{
	static uint8_t oldState;						//holds the old value of the keyboard IO port
	char newState=0;

	if (KEY1_PIN & (1<<KEY1_BIT)) newState |= 0x01;
	if (KEY2_PIN & (1<<KEY2_BIT)) newState |= 0x02;
	if (KEY3_PIN & (1<<KEY3_BIT)) newState |= 0x04;
	if (KEY4_PIN & (1<<KEY4_BIT)) newState |= 0x08;

	if (!(newState & 0x01) && (oldState & 0x01)) lastkey=1;
	if (!(newState & 0x02) && (oldState & 0x02)) lastkey=2;
	if (!(newState & 0x04) && (oldState & 0x04)) lastkey=3;
	if (!(newState & 0x08) && (oldState & 0x08)) lastkey=4;

	oldState=newState;								//update oldD
}

char GetKey()
{
	char tmp=lastkey;
	lastkey=0;
	return tmp;
}